import { AfterViewInit, ElementRef, OnDestroy } from '@angular/core';
import { Datepicker } from 'vanillajs-datepicker';
import { AbstractControl, ControlValueAccessor, FormGroup, ValidationErrors, Validator } from '@angular/forms';
import { DateHelper } from '../helpers/date.helper';
import { FormHelper } from '../helpers/form.helper';
import * as i0 from "@angular/core";
export declare class NgxSimpleDatepickerComponent implements ControlValueAccessor, Validator, AfterViewInit, OnDestroy {
    dpContainer: ElementRef;
    form: FormGroup;
    inputKey: string;
    placeholder?: string;
    formGlobalError: boolean;
    language: string;
    verticalPosition?: 'top' | 'bottom';
    notInFuture: boolean;
    notInPast: boolean;
    datepicker?: Datepicker;
    value?: Date;
    displayedValue: string;
    hasFocus: boolean;
    disabled: boolean;
    touched: boolean;
    onChange: (date?: Date) => void;
    onTouched: () => void;
    dateH: typeof DateHelper;
    formH: typeof FormHelper;
    mask: (string | RegExp)[];
    autoCorrectedDatePipe: any;
    private maskRegex;
    constructor();
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    onModelChange(dateStr: string): void;
    onDateChange(event: CustomEvent): void;
    writeValue(date?: Date): void;
    validate(control: AbstractControl): ValidationErrors | null;
    openDatepicker(): void;
    registerOnChange(fn: (date?: Date) => void): void;
    registerOnTouched(fn: () => void): void;
    setDisabledState(isDisabled: boolean): void;
    onFocus(value: boolean): void;
    private valueToDisplayedValue;
    private markAsTouched;
    private createDatepicker;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgxSimpleDatepickerComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgxSimpleDatepickerComponent, "ngx-simple-datepicker", never, { "form": "form"; "inputKey": "inputKey"; "placeholder": "placeholder"; "formGlobalError": "formGlobalError"; "language": "language"; "verticalPosition": "verticalPosition"; "notInFuture": "notInFuture"; "notInPast": "notInPast"; }, {}, never, never, false, never>;
}
